import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Roboter extends Actor
{
    private int energieRoboter = 0;
    private int lebensenergie = 10;
    
    public void act() 
    {
        this.checkKeys();
        this.checkCollisionWithBatterie();
        this.checkCollisionWithBombe();
    } 

    public void checkKeys()
    {
        // Objekt in die gewünschte Richtung bewegen und passendes Bild anzeigen:
        if(Greenfoot.isKeyDown("a"))
        {
            this.moveLeft();
        }

        if(Greenfoot.isKeyDown("d"))
        {
            this.moveRight();
        }

        if(Greenfoot.isKeyDown("w"))
        {
            this.moveUp();
        }  

        if(Greenfoot.isKeyDown("s"))
        {
            this.moveDown();
        }
    } 

    public void moveLeft()
    {
        this.setLocation(getX() - 5, getY());
    }

    public void moveRight()
    {
        this.setLocation(getX() + 5, getY());
    }

    public void moveUp()
    {
        this.setLocation(this.getX() , this.getY() - 5); 
    }

    public void moveDown()
    {
        this.setLocation(this.getX() , this.getY() + 5); 
    }

    public void checkCollisionWithBatterie()
    {
        Batterie meineBatterie;
        meineBatterie = (Batterie)this.getOneIntersectingObject(Batterie.class);

        if(meineBatterie != null)
        {
            this.energieRoboter = this.energieRoboter + meineBatterie.getEnergieBatterie();
            meineBatterie.setEnergieBatterie(0);
            this.getWorld().showText("Energie: " + this.energieRoboter, 700, 50);
        }
    }
    
    public void checkCollisionWithBombe()
    {
        Bombe meineBombe;
        meineBombe = (Bombe)this.getOneIntersectingObject(Bombe.class);

        if(meineBombe != null)
        {
            this.lebensenergie = this.lebensenergie - meineBombe.getSprengkraft();
            meineBombe.setSprengkraft(0);
            this.getWorld().showText("Lebensenergie: " + this.lebensenergie, 100, 50);
        }
    }

}
